uniform sampler2D Texture;
uniform sampler2D PickID;

uniform sampler2D StartRay;
uniform sampler2D StopRay;
uniform sampler3D volumeData;

uniform bool MIP;


vec4 transfer(float scalar){
    return vec4(scalar);
}

void main(void)
{
    // gl_FragColor = vec4(gl_TexCoord[0].st,0,1);
    //gl_FragColor = texture2D(PickID,gl_TexCoord[0].st);
    //gl_FragColor = texture2D(StartRay,gl_TexCoord[0].st);
    gl_FragColor = vec4(texture2D(StopRay,gl_TexCoord[0].st).xyz,1);


   // gl_FragColor = vec4(gl_TexCoord[0].st,0,1);

    vec3 front = texture2D(StartRay,gl_TexCoord[0].st).xyz;
    vec3 back = texture2D(StopRay,gl_TexCoord[0].st).xyz;


    if(front == back){
        gl_FragColor = vec4(texture2D(Texture,gl_TexCoord[0].st).xyz,1);
    }else{

        vec3 ray = back-front;
         float rayLength = length(ray);
         vec3 stepVector = 0.01 * ray/rayLength;

         vec3 pos = front;
         vec4 dst = vec4(0);
         float maxfloat = 0;

         while (dst.a < 1 && rayLength > 0) {

             float density = texture3D(volumeData, pos).x;
             maxfloat = max(density,maxfloat);

             vec4 src = transfer(density);

             src.rgb *= src.a;

             dst = (1.0 - dst.a) * src + dst;
             pos += stepVector;
             rayLength -= 0.01;
         }

         if(MIP) {
            gl_FragColor = transfer(maxfloat);
         }else{
            gl_FragColor = dst;
         }


        // gl_FragColor = vec4(gl_TexCoord[0].xyz,1);
        //gl_FragColor = vec4(vec3(count),1);
        //gl_FragColor = vec4(normalize(step),1);
        //gl_FragColor = vec4(normalize(gl_ModelViewProjectionMatrixInverse*vec4(0,1,0,0.0)));
        //gl_FragColor = vec4(texture3D(volumeData,vec3(front.xy,0.5)).x);
    }
}


